package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.io.*;
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Figure { //класс содержащий стандартную 3D модель
    public Vertex[] vertex; //вершинывершины
    public Element3D[] element; // 3D элементы
    
    
    
    public Figure(String file) {
        try {
            DataInputStream dis = new DataInputStream(getClass().getResourceAsStream(file));
            create(dis, this);
            dis.close();
        } catch (IOException ex) {
            System.err.println("ERROR create figure(String file) " + ex);
        }
    }
    public Figure(DataInputStream dis) {
        try {
            create(dis, this);
        } catch (IOException ex) {
            System.err.println("ERROR create figure(DataInputStream dis) " + ex);
        }
    }
    
    
    public void setMatrix(Matrix m) { // поворачиваем вершины
        for (int i = vertex.length - 1; i >= 0; i--) {
            vertex[i].setMatrix(m);
        }
        for (int i = element.length - 1; i >= 0; i--) {
            element[i].setMatrix(m);
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private static void create(DataInputStream dis, Figure f) throws IOException {
        int ver = dis.readShort(); // сколько вершин
        int col = dis.readShort(); // сколько цветов
        int pol3V = dis.readShort(); // сколько треуголных полигонрв
        int pol4V = dis.readShort(); // сколько четырёхугольных полигонрв
        
        
        f.vertex = new Vertex[ver];
        for (int i = 0; i < f.vertex.length; i++) { //загружаем вершины
            f.vertex[i] = new Vertex(dis);
        }
        
        
        int[] color = new int[col];
        for (int i = 0; i < col; i++) { //загружаем цвета
            color[i] = dis.readInt();
        }
        
        
        f.element = new Element3D[pol3V + pol4V]; //создаём сассив элементов
        int e = 0; //номер элемента в массиве
        for (int i = 0; i < pol3V; i++) { //загружаем треугольные полигоны
            f.element[e] = new Polygon3V(dis, f.vertex, color);
            e++;
        }
        for (int i = 0; i < pol4V; i++) { //загружаем четырёхугольные полигоны
            f.element[e] = new Polygon4V(dis, f.vertex, color);
            e++;
        }
        
        
        
        
        System.out.println("вершин: " + f.vertex.length);
        System.out.println("полигонов: " + f.element.length);
    }
    
    
    
    
    
    
    
    
    
}
    
    
    
    
