package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.iceberg.*;
import java.io.*;
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Polygon4V extends Element3D {
    
    public Vertex v1, v2, v3, v4;
    
    private byte colorR;
    private byte colorG;
    private byte colorB;
    
    
    private Normal normal;
    
    public Polygon4V(DataInputStream dis, Vertex[] ver, int[] colors) {
        try {
            short a1 = dis.readShort();
            short a2 = dis.readShort();
            short a3 = dis.readShort();
            short a4 = dis.readShort();
            short col = dis.readShort();
            
            v1 = ver[a1];
            v2 = ver[a2];
            v3 = ver[a3];
            v4 = ver[a4];
            int color = colors[col];

            colorR = (byte) ((color>>16) & 0xff);
            colorG = (byte) ((color>>8) & 0xff);
            colorB = (byte) (color & 0xff);
        } catch (IOException ex) {System.err.println("ERROR new Polygon4V "+ex);}
        normal = new Normal(this);
    }
    
    
    
    
    public final void paint(Graphics g) {
        
        int a = (normal.nx*Light.x + normal.ny*Light.y + normal.nz*Light.z) >> 12;
        
        if(a>0) {
            a=0;
        }
        if(a<-4096) {
            a=-4096;
        }
        
        int cr = colorR & 0xff;
        int cg = colorG & 0xff;
        int cb = colorB & 0xff;
        
        cr = (cr*-a)>>12;
        cg = (cg*-a)>>12;
        cb = (cb*-a)>>12;
        
        g.setColor(cr, cg, cb);
        
        g.fillTriangle(v1.sx, v1.sy, v2.sx, v2.sy, v4.sx, v4.sy);
        g.fillTriangle(v2.sx, v2.sy, v3.sx, v3.sy, v4.sx, v4.sy);
        // 3              4
        // |--------------|
        // |------------/-|
        // |----------/---|
        // |--------/-----|
        // |------/-------|
        // |----/---------|
        // |--/-----------|
        // |/-------------|
        // 2              1
    }
    
    public final void setMatrix(Matrix m) { //средняя Z координата
        sz = (short) ((v1.z+v2.z+v3.z+v4.z) >> 2);
        normal.setMatrix(m);
    }
    
    
    public final boolean ifVisible() {
        if(sz>0 && sz<G3D.range && normal.nz<0) {
            return true;
        } else {
            return false;
        }
    }
    
    
    

}